snaxdart 1.0.1

  • Readme
  • Changelog
  • Installing
  • 43

eosdart #

Build Status

A library for EOS Node API

It talks to the EOS nodes by the given endpoint and API method.

Sample #

Sample Flutter application uses eosdart to fetch EOS account info:

https://github.com/primes-network/sample_flutter_eosdart

Usage #

A simple usage example:

import 'package:eosdart/eosdart.dart';

main() {
  EOSClient client = EOSClient('https://eos.greymass.com', 'v1');

  // Get EOS Node Info
  client.getInfo().then((NodeInfo nodeInfo) {
    print(nodeInfo);
  });

  // Get EOS Abi
  client.getAbi('eosio.token').then((AbiResp abi) {
    print(abi);
  });

  // Get EOS Raw Abi
  client.getRawAbi('eosio.token').then((AbiResp abi) {
    print(abi);
  });

  // Get EOS Raw code and Abi
  client.getRawCodeAndAbi('eosio.token').then((AbiResp abi) {
    print(abi);
  });

  // Get EOS Block Info
  client.getBlock('298674').then((Block block) {
    print(block);
  });

  // Get Account Info
  client.getAccount('eosio.token').then((Account account) {
    print(account);
  });

  // Get Account Actions
  client.getActions('eosio.token', pos: -1, offset: -1).then((Actions actions) {
    print(actions);
  });

  // Get Transaction
  client
      .getTransaction(
          '83875faeb054ba20b20f392418e3a0002c4bb1c36cc4e3fde15cbd0963da8a15')
      .then((TransactionBlock transaction) {
    print(transaction);
  });

  // Get Accounts from public key
  client
      .getKeyAccounts('EOS8RWQpzzMi5uFXXXAChi4dHnyxMYKKdAQ3Y3pHQTrvhzGk95LbT')
      .then((AccountNames accountNames) {
    print(accountNames);
  });

  // Get currency balance
  client
      .getCurrencyBalance('parslseed123', 'newdexpocket')
      .then((List<Holding> balance) {
    print(balance);
  });
}

Push Transaction #

import 'package:eosdart/eosdart.dart';

main() {
  EOSClient client = EOSClient('http://127.0.0.1:8888', 'v1',
      privateKeys: ["5J9b3xMkbvcT6gYv2EpQ8FD4ZBjgypuNKwE1jxkd7Wd1DYzhk88"]);

  List<Authorization> auth = [
    Authorization()
      ..actor = 'bob'
      ..permission = 'active'
  ];

  Map data = {
    'from': 'bob',
    'to': 'alice',
    'quantity': '0.0001 SYS',
    'memo': '',
  };

  List<Action> actions = [
    Action()
      ..account = 'eosio.token'
      ..name = 'transfer'
      ..authorization = auth
      ..data = data
  ];

  Transaction transaction = Transaction()..actions = actions;

  // will print something like:
  // {transaction_id: c28bf8c168741adb96f3aef8723e953140cc60ecd20cec0d22e5a2dc5cdd5571, processed: {id: c28bf8c168741adb96f3aef8723e953140cc60ecd20cec0d22e5a2dc5cdd5571, block_num: 576745, block_time: 2019-05-03T06:07:54.500, producer_block_id: null, receipt: {status: executed, cpu_usage_us: 216, net_usage_words: 16}, elapsed: 216, net_usage: 128, scheduled: false, action_traces: [{receipt: {receiver: eosio.token, act_digest: 117d5840be4ff21fad764d5d497182916f76e772b279e65e964bccfa7c888331, global_sequence: 576794, recv_sequence: 17, auth_sequence: [[bob, 37]], code_sequence: 1, abi_sequence: 1}, act: {account: eosio.token, name: transfer, authorization: [{actor: bob, permission: active}], data: {from: bob, to: alice, quantity: 0.0001 SYS, memo: }, hex_data: 0000000000000e3d0000000000855c340100000000000000045359530000000000}, context_free: false, elapsed: 73, console: , trx_id: c28bf8c168741adb96f3aef8723e953140cc60ecd20cec0d22e5a2dc5cdd5571, block_num: 576745, block_time: 2019-05-03T06:07:54.500, producer_block_id: null, account_ram_deltas: [], except: null, inline_traces: [{receipt: {receiver: bob, act_digest: 117d5840be4ff21fad764d5d497182916f76e772b279e65e964bccfa7c888331, global_sequence: 576795, recv_sequence: 14, auth_sequence: [[bob, 38]], code_sequence: 1, abi_sequence: 1}, act: {account: eosio.token, name: transfer, authorization: [{actor: bob, permission: active}], data: {from: bob, to: alice, quantity: 0.0001 SYS, memo: }, hex_data: 0000000000000e3d0000000000855c340100000000000000045359530000000000}, context_free: false, elapsed: 2, console: , trx_id: c28bf8c168741adb96f3aef8723e953140cc60ecd20cec0d22e5a2dc5cdd5571, block_num: 576745, block_time: 2019-05-03T06:07:54.500, producer_block_id: null, account_ram_deltas: [], except: null, inline_traces: []}, {receipt: {receiver: alice, act_digest: 117d5840be4ff21fad764d5d497182916f76e772b279e65e964bccfa7c888331, global_sequence: 576796, recv_sequence: 15, auth_sequence: [[bob, 39]], code_sequence: 1, abi_sequence: 1}, act: {account: eosio.token, name: transfer, authorization: [{actor: bob, permission: active}], data: {from: bob, to: alice, quantity: 0.0001 SYS, memo: }, hex_data: 0000000000000e3d0000000000855c340100000000000000045359530000000000}, context_free: false, elapsed: 2, console: , trx_id: c28bf8c168741adb96f3aef8723e953140cc60ecd20cec0d22e5a2dc5cdd5571, block_num: 576745, block_time: 2019-05-03T06:07:54.500, producer_block_id: null, account_ram_deltas: [], except: null, inline_traces: []}]}], except: null}}
  client.pushTransaction(transaction, broadcast: true).then((trx) {
    print(trx);
  });
}

Installing #

https://pub.dartlang.org/packages/eosdart#-installing-tab-

Features and bugs #

Please file feature requests and bugs at the issue tracker.

1.0.1 #

  • Fix float32 and float64 errors

1.0.0 #

  • Snax migration

0.4.1 #

support:

  • /v1/chain/get_table_rows

0.4.0 #

  • Initial version to support push transaction

0.3.3 #

  • Update README.md

0.3.2 #

  • Correct the async operation
  • Better error handling

0.3.1 #

Fix: Class name conflict with flutter - https://github.com/primes-network/eosdart/issues/12

0.3.0 #

Supports the following APIs:

  • /v1/chain/get_info
  • /v1/chain/get_block
  • /v1/chain/get_block_header_state
  • /v1/chain/get_account
  • /v1/chain/get_abi
  • /v1/chain/get_raw_abi
  • /v1/chain/get_raw_code_and_abi
  • /v1/chain/get_currency_balance
  • /v1/history/get_actions
  • /v1/history/get_transaction
  • /v1/history/get_key_accounts

0.0.1 #

  • Initial version, created by Stagehand

Use this package as a library

1. Depend on it

Add this to your package's pubspec.yaml file:


dependencies:
  snaxdart: ^1.0.1

2. Install it

You can install packages from the command line:

with pub:


$ pub get

with Flutter:


$ flutter pub get

Alternatively, your editor might support pub get or flutter pub get. Check the docs for your editor to learn more.

3. Import it

Now in your Dart code, you can use:


import 'package:snaxdart/snaxdart.dart';
  
Popularity:
Describes how popular the package is relative to other packages. [more]
0
Health:
Code health derived from static analysis. [more]
87
Maintenance:
Reflects how tidy and up-to-date the package is. [more]
83
Overall:
Weighted score of the above. [more]
43
Learn more about scoring.

We analyzed this package on Dec 7, 2019, and provided a score, details, and suggestions below. Analysis was completed with status completed using:

  • Dart: 2.6.1
  • pana: 0.12.21

Platforms

Detected platforms: Flutter, web, other

No platform restriction found in primary library package:snaxdart/snaxdart.dart.

Health suggestions

Fix lib/src/serialize.dart. (-7.71 points)

Analysis of lib/src/serialize.dart reported 16 hints, including:

line 220 col 3: Prefer using /// for doc comments.

line 222 col 11: Unnecessary new keyword.

line 226 col 3: Prefer using /// for doc comments.

line 228 col 11: Unnecessary new keyword.

line 232 col 3: Prefer using /// for doc comments.

Fix lib/src/client.dart. (-2.48 points)

Analysis of lib/src/client.dart reported 5 hints:

line 47 col 5: Future results in async function bodies must be awaited or marked unawaited using package:pedantic.

line 128 col 12: Use isNotEmpty instead of length

line 184 col 43: Unnecessary new keyword.

line 266 col 19: Unnecessary new keyword.

line 302 col 18: Unnecessary new keyword.

Fix lib/src/numeric.dart. (-1.99 points)

Analysis of lib/src/numeric.dart reported 4 hints:

line 120 col 16: Unnecessary new keyword.

line 182 col 16: Unnecessary new keyword.

line 224 col 11: Unnecessary new keyword.

line 264 col 32: Unnecessary new keyword.

Fix lib/src/models/abi.dart. (-0.50 points)

Analysis of lib/src/models/abi.dart reported 1 hint:

line 51 col 10: This function has a return type of 'Abi', but doesn't end with a return statement.

Fix lib/src/models/transaction.dart. (-0.50 points)

Analysis of lib/src/models/transaction.dart reported 1 hint:

line 135 col 26: The value of the local variable 'aa' isn't used.

Maintenance issues and suggestions

Support latest dependencies. (-10 points)

The version constraint in pubspec.yaml does not support the latest published versions for 1 dependency (json_annotation).

The package description is too short. (-7 points)

Add more detail to the description field of pubspec.yaml. Use 60 to 180 characters to describe the package, what it does, and its target use case.

Maintain an example.

None of the files in the package's example/ directory matches known example patterns.

Common filename patterns include main.dart, example.dart, and snaxdart.dart. Packages with multiple examples should provide example/README.md.

For more information see the pub package layout conventions.

Dependencies

Package Constraint Resolved Available
Direct dependencies
Dart SDK >=2.0.0 <3.0.0
http ^0.12.0+1 0.12.0+2
json_annotation ^2.2.0 2.4.0 3.0.0
pointycastle ^1.0.1 1.0.2
snaxdart_ecc ^1.0.0 1.0.0
Transitive dependencies
async 2.4.0
bs58check 1.0.1
charcode 1.1.2
collection 1.14.12
convert 2.1.1
crypto 2.1.4
hex 0.1.2
http_parser 3.1.3
meta 1.1.8
path 1.6.4
pedantic 1.9.0
source_span 1.5.5
string_scanner 1.0.5
term_glyph 1.1.0
typed_data 1.1.6
Dev dependencies
build_runner ^1.0.0
json_serializable ^2.0.0
test ^1.0.0